/*
PPKMouseAddon
 by Mnjul/purincess (Min-Zhong Lu)
 # Middle Sea, Mnjul's Intimate Home

Copyright 2007-2010 Min-Zhong Lu

This file is part of PPKMouseAddon.

PPKMouseAddon is free software: you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as published by
the Free Software Foundation, either version 3 of the License, or (at your
option) any later version.

PPKMouseAddon is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
License for more details.

You should have received a copy of the GNU Lesser General Public License
along with PPKMouseAddon.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef __APPLICATION_UTILITY_H
#define __APPLICATION_UTILITY_H

class ApplicationUtility{
private:
	ApplicationUtility(){
	}
	~ApplicationUtility(){
	}
	ApplicationUtility(const ApplicationUtility&);	//no copy constructor
	ApplicationUtility& operator=(const ApplicationUtility*);	// no assignment operation constructor

public:
	static ApplicationUtility& getInstance(){
		static ApplicationUtility instance;
		return instance;
	}

protected:
	void seTranslatorInternal(unsigned int errCode, EXCEPTION_POINTERS* exPtr) const;

public:
	static void seTranslator(unsigned int errCode, EXCEPTION_POINTERS* exPtr){
		ApplicationUtility::getInstance().seTranslatorInternal(errCode, exPtr);
	}

	void showTypeSafeErrorMessage(const unsigned int errCode, const wchar_t* from) const;
	void showLastErrorMessage(const wchar_t* message, UINT type = MB_ICONEXCLAMATION) const;
};

#endif