/*
PPKMouseAddon
 by Mnjul/purincess (Min-Zhong Lu)
 # Middle Sea, Mnjul's Intimate Home

Copyright 2007-2010 Min-Zhong Lu

This file is part of PPKMouseAddon.

PPKMouseAddon is free software: you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as published by
the Free Software Foundation, either version 3 of the License, or (at your
option) any later version.

PPKMouseAddon is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
License for more details.

You should have received a copy of the GNU Lesser General Public License
along with PPKMouseAddon.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "stdafx.h"
#include "Registry.h"

/*
std::wstring Registry::getGlobalRegistry(const HKEY root, const std::wstring& keyDir, const std::wstring& valueName, const std::wstring& defValue) const{
	HKEY hkey;
	wchar_t* pBuffer = NULL;

	DWORD bufferSize = 0;

	if(RegOpenKeyW(root, keyDir.c_str(), &hkey) != ERROR_SUCCESS){
		return std::wstring(defValue);
	}

	if(RegQueryValueExW(hkey, valueName.c_str(), NULL, NULL, NULL, &bufferSize) != ERROR_SUCCESS){
		RegCloseKey(hkey);
		return std::wstring(defValue);
	}

	pBuffer = new wchar_t[bufferSize];

	if(pBuffer == NULL){
		RegCloseKey(hkey);
		return std::wstring(defValue);
	}

	if(RegQueryValueExW(hkey, valueName.c_str(), NULL, NULL, reinterpret_cast<LPBYTE>(pBuffer), &bufferSize) != ERROR_SUCCESS){
		RegCloseKey(hkey);
		return std::wstring(defValue);
	}else{
		RegCloseKey(hkey);
		std::wstring result(pBuffer);
		delete[] pBuffer;
		return result;
	}
}

void Registry::putGlobalRegistry(const HKEY root, const std::wstring& keyDir, const std::wstring& valueName, const std::wstring& value) const{
	HKEY hkey;

	RegCreateKeyW(root, keyDir.c_str(), &hkey);
	RegSetValueExW(hkey, valueName.c_str(), NULL, REG_SZ, reinterpret_cast<const BYTE*>(value.c_str()), value.length() * sizeof(wchar_t));
	RegCloseKey(hkey);
}
*/

DWORD Registry::getGlobalRegistry(const HKEY root, const std::wstring& keyDir, const std::wstring& valueName, const DWORD defValue) const{
	HKEY hkey;
	DWORD buffer = defValue;

	DWORD bufferSize = sizeof(buffer);

	if(RegOpenKeyW(root, keyDir.c_str(), &hkey) != ERROR_SUCCESS){
		return defValue;
	}

	if(RegQueryValueExW(hkey, valueName.c_str(), NULL, NULL,reinterpret_cast<LPBYTE>(&buffer), &bufferSize) != ERROR_SUCCESS){
		RegCloseKey(hkey);
		return defValue;
	}else{
		return buffer;
	}
}

void Registry::putGlobalRegistry(const HKEY root, const std::wstring& keyDir, const std::wstring& valueName, const DWORD value) const{
	HKEY hkey;

	RegCreateKeyW(root, keyDir.c_str(), &hkey);
	RegSetValueExW(hkey, valueName.c_str(), NULL, REG_DWORD, reinterpret_cast<const BYTE*>(&value), sizeof(value));
	RegCloseKey(hkey);
}